﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using System.Collections.Generic;

namespace SilverlightApplication1
{
    public class MyDataObject
    {
        public int Id { get; set; }
        public string StringValue { get; set; }
        public double DoubleValue { get; set; }
        public DateTime DateTimeValue { get; set; }

        public ObservableCollection<MyDataObject> HierarchicalData { get; set; }
    }

    public class MyData : ObservableCollection<MyDataObject>
    {
        private void FillDataCollection(ObservableCollection<MyDataObject> collection)
        {
            collection.Add(new MyDataObject()
            {
                Id = 1,
                StringValue = "test",
                DoubleValue = 0,
                DateTimeValue = DateTime.Now
            });

            collection.Add(new MyDataObject()
            {
                Id = 2,
                StringValue = "test1",
                DoubleValue = 5.6,
                DateTimeValue = DateTime.Now
            });

            collection.Add(new MyDataObject()
            {
                Id = 3,
                StringValue = "test123",
                DoubleValue = 10.2,
                DateTimeValue = DateTime.Now
            });

            collection.Add(new MyDataObject()
            {
                Id = 4,
                StringValue = "test12345",
                DoubleValue = 23,
                DateTimeValue = DateTime.Now
            });
        }

        public MyData()
        {
            FillDataCollection(this);

            foreach (MyDataObject dataObject in this)
            {
                dataObject.HierarchicalData = new ObservableCollection<MyDataObject>();
                FillDataCollection(dataObject.HierarchicalData);
            }
        }
    }
}
